# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import Instance, Singleton

from .i_settings_manager import ISettingsManager


class SettingsManager(Singleton):
    """ The SettingsManager class is a singleton that provides access to a
    default settings manager.
    """

    # The settings manager instance.
    instance = Instance(ISettingsManager)

    @instance.default
    def instance(self):
        """ Invoked to return the settings manager. """

        from .default_settings_manager import SettingsManager

        return SettingsManager()
